# IDEA 2020.1.1
::: details 目录
[[toc]]
:::

## 下载
### 官网下载

下载页面：[https://www.jetbrains.com/idea/download/#section=windows](https://www.jetbrains.com/idea/download/#section=windows)

下载地址：[https://download.jetbrains.com/idea/ideaIU-2020.1.1.exe?_ga=2.167364414.1627481570.1590717942-16051737.1590627630](https://download.jetbrains.com/idea/ideaIU-2020.1.1.exe?_ga=2.167364414.1627481570.1590717942-16051737.1590627630)

### 百度网盘下载
链接：[https://pan.baidu.com/s/1HlI1atmeOiHs4dLK668T6w ](https://pan.baidu.com/s/1HlI1atmeOiHs4dLK668T6w)

提取码：y7xa

## 安装
运行安装程序“ideaIU-2020.1.1.exe”；

![安装 idea](./img/idea_001.jpg)

点击“Next”按钮； 

![安装 idea](./img/idea_002.jpg)

输入或点击“Browse”按钮选择 IDEA 的安装文件夹，点击“Next”按钮；

![安装 idea](./img/idea_003.jpg)

按上图所示，勾选对应的安装属性。点击“Next”按钮；

![安装 idea](./img/idea_004.jpg)

点击“Install”按钮，开始安装；

![安装 idea](./img/idea_005.jpg)

点击“Finish”按钮，完成安装。

## 破解

## 配置
![配置 idea](./img/idea-setting_001.jpg)

idea 配置需要点击主窗口菜单 “File” -> “Settings...” 打开配置对话框，如下图：

![配置 idea](./img/idea-setting_002.jpg)

### 配置字符集 （UTF-8）
UTF-8 解决中文乱码，面向国际化 , 防止字符集不一样导致出现乱码。

![配置 idea](./img/idea-setting_008.jpg)

在配置对话框中点击 Editor -> File Encodings , 有三个地方需要改为UTF-8 ，最下面的字符不要忘记勾选否则会不生效。

### 配置 Copyrigth 
代码中添加 Copyrigth 标明代码从什么机构出品，从 Copyrigth 可以知道代码是否出自同一机构，对代码编写人员会产生归属感、荣誉感。

![配置 idea](./img/idea-setting_003.jpg)

配置每个代码文件注释头，在配置对话框点击 Editor -> Copyrigth -> Copyrigth Profiles 然后点击+（加号）。 

![配置 idea](./img/idea-setting_004.png)
 
创建名称为 persagy 的 Copyrigth ，persagy 为公司标志。

![配置 idea](./img/idea-setting_005.jpg)
 
点击 persagy ，替换框选内容，点击 apply 保存 ，内容如下:
```
**********************************************************************************************************************

         !!
       .F88X
       X8888Y
     .}888888N;
       i888888N;        .:!              .I$WI:
         R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
         .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
           +888888N;  .8888888Y                                  "&&8Y.}8,
           ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
             ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
             18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
           .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
           8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
         i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
       .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
     .:R888888I
     .&888888I                                          Copyright (c) 2016-$today.year.  博锐尚格科技股份有限公司
       ~8888'
       .!88~                                                                     All rights reserved.

**********************************************************************************************************************
```

![配置 idea](./img/idea-setting_006.jpg)

点击 Copyrigth 然后点击下拉三角选择 persagy ,然后点击 Apply -> OK 保存选择的配置

![配置 idea](./img/idea-setting_007.jpg)
 
点击主菜单 Code -> Update Copyrigth... 在对话框中点击 Update Copyrigth 就完成了对所有文件的设置

### 配置 gradle
使用 gradle 构建管理，方便自动构建减少手动开发，语法简洁易懂，不受不同操作系统限制

#### 官网下载

下载页面：[https://services.gradle.org/distributions/](https://services.gradle.org/distributions/)

#### 百度网盘下载
链接：[https://pan.baidu.com/s/13qkQlBKXh_hlIOkjUErpbw](https://pan.baidu.com/s/13qkQlBKXh_hlIOkjUErpbw)

提取码：excc 

根据使用的 ide 以及个人开发需求选择需要的 Gradle 版本下载， 解压到D盘server-gradle (D:\server-gradle)

#### idea 配置 Gradle

![配置 idea](./img/idea-setting_009.jpg)

点击配置菜单 Build Execution, Deployment -> Build Tools ， Gradle user home: 选择下载后Gradle的地址，Use Gradle from 选择 Specified location 后面选择和上面一样的 Gradle 地址即可。

![配置 idea](./img/idea-setting_010.jpg)

点击右侧 Gradle 在浮动窗口中点击刷新图标进行项目构建。

## 项目创建过程

### 创建项目
### 添加 APP 模块
### 添加支持库模块

## 关键文件说明
### git 忽略文件
::: details 查看代码
<<< @/docs/setup/dev/src/project/gitignore
:::

### build.gradle 
build.gradle 是项目的构建文件

::: details 查看代码
<<< @/docs/setup/dev/src/project/build.gradle
:::

### settings.gradle 项目设置文件
settings.gradle 是多项目配置文件

::: details 查看代码
<<< @/docs/setup/dev/src/project/settings.gradle
:::

### gradle.properties 属性配置文件
::: details 查看代码
<<< @/docs/setup/dev/src/project/gradle.properties
:::